#include "FileMaster.h"
#include "Functors.h"
#include <ctime>
#include <vector>
#include <algorithm>
#include <string>
#include <exception>

FileMaster::FileMaster()  {}

FileMaster::~FileMaster() {}

void FileMaster::createData(std::ofstream& outStream) {
	if (!outStream.is_open()) {
		throw std::runtime_error("File is not opened!");
	}

	srand(time(nullptr));
	for (int i = 0; i < 100; i++) {
		int newElement = rand() % 101 - 50;
	    outStream << std::to_string(newElement) + " ";
	}
}

void FileMaster::createData(std::ostream_iterator<int> it) {
	srand(time(nullptr));
	std::vector<int> tmpVec(100);
	std::generate(tmpVec.begin(), tmpVec.end(), []() {
		return rand() % 101 - 50;
		}
	);

	std::copy(tmpVec.begin(), tmpVec.end(), it);
}

void FileMaster::modify(std::istream_iterator<int> inItBegin, std::istream_iterator<int> inItEnd, std::ostream_iterator<int> outItBegin) {
	int summ = 0;
	unsigned count = 0;
	std::vector<int> buffer(100);
	std::for_each(inItBegin, inItEnd, [&summ, &count](int current) {
		summ += current;
		++count;
		}
	);
	std::copy(inItBegin, inItEnd, buffer.begin());
	int avg = summ / count;
	std::transform(buffer.begin(), buffer.end(), outItBegin, [&avg](auto& element) {
	    
	    // !!! std::transform не меняет данный контейнер - он сохраняет результат в новый контейнер.
	    
	    
		if (abs(element) % 2) {
			element = element / avg;
		}
		return element;
		}
	);
}