#pragma once
#include "Struct.h"
#include <fstream>
#include <iostream>
#include "FileException.h"
#include <algorithm>

using namespace std;
ofstream & operator << (ofstream & file, const BooksInfo & info)
{
	file  << endl <<"Номер читательского билета: " << info.NumLibTicket;
	file << endl << "Фамилия абонента: " << info.SurnameAb;
	file << endl << "Дата выдачи : " << info.Date;
	file << endl << "Срок возврата (количество дней) : " << info.AmountDays;
	file << endl << "Автор:  " << info.Author;
	file << endl << "Название: " << info.Name;
	file << endl << "Год издания:  " << info.Year;
	file << endl << "Издательство: " << info.Publishing;
	file << endl << "Цена: " << info.Price << endl;;
	return file;
}

void WriteToFile()
{
	BooksInfo info;
	ofstream fout;
	int ticket;
	map<int, BooksInfo> MyMap;
	int i = 0;
	while (cout <<endl<< "Введите номер читательского билета " << endl << "Для завершения напишите '0'" << endl,
		cin >> ticket, ticket != 0)
	{
		info.NumLibTicket = ticket;
		cout << endl << "Фамилия абонента: ";
		cin >> info.SurnameAb;
		cout << endl << "Дата выдачи : ";
		cin >> info.Date;
		cout << endl << "Срок возврата (количество дней) : ";
		cin >> info.AmountDays;
		cout << endl << "Автор:  ";
		cin >> info.Author;
		cout << endl << "Название: ";
		cin >> info.Name;
		cout << endl << "Год издания:  ";
		cin >> info.Year;
		cout << endl << "Издательство: ";
		cin >> info.Publishing;
		cout << endl << "Цена: ";
		cin >> info.Price;
		cout << endl;
		MyMap.emplace(i, info);
		i++;
	}
	fout.open("FileBin.bin", ios::binary);
	if (!fout.is_open())
	{
		throw FileException("Ошибка открытия файла"); 
	}
	for (auto& it : MyMap)
	{
		fout.write(reinterpret_cast<char*>(&it.second), sizeof(it.second));
	}
	fout.close();
}

void DeleteFromFile(int num)
{
	BooksInfo info;
	ifstream Bin;
	int i = 0;
	map <int, BooksInfo> mymap;
	Bin.open("FileBin.bin", ios::binary);
	while (Bin.read(reinterpret_cast<char*> (&info), sizeof(info)))
	{
		mymap.emplace(i, info);
		++i;
	}
	mymap.erase(num);
	Bin.close();
	ofstream bin;
	ofstream filetxt;
	filetxt.open("Result.txt");
	bin.open("FileBin.bin", ios::binary);
	for (auto& it : mymap)
	{
		bin.write(reinterpret_cast<char*>(&it.second), sizeof(it.second));
		filetxt << it.second;
	}


}

void ReplaceInFile(int number)
{
	BooksInfo info;
	BooksInfo newinfo;
	ifstream Bin;
	int i = 0;
	map <int, BooksInfo> mymap;
	Bin.open("FileBin.bin", ios::binary);
	while (Bin.read(reinterpret_cast<char*> (&info), sizeof(info)))
	{
		mymap.emplace(i, info);
		++i;
	}
	
		cout << endl << "Введите номер читательского билета: ";
		cin>>newinfo.NumLibTicket ;
		cout << endl << "Фамилия абонента: ";
		cin >> newinfo.SurnameAb;
		cout << endl << "Дата выдачи : ";
		cin >> info.Date;
		cout << endl << "Срок возврата (количество дней) : ";
		cin >> info.AmountDays;
		cout << endl << "Автор:  ";
		cin >> info.Author;
		cout << endl << "Название: ";
		cin >> info.Name;
		cout << endl << "Год издания:  ";
		cin >> info.Year;
		cout << endl << "Издательство: ";
		cin >> info.Publishing;
		cout << endl << "Цена: ";
		cin >> info.Price;
		cout << endl;
		mymap.emplace(number, newinfo);
	Bin.close();
	ofstream bin;
	ofstream txt;
	txt.open("Result.txt");
	bin.open("FileBin.bin", ios::binary);
	for (auto& it : mymap)
	{
		bin.write(reinterpret_cast<char*>(&it.second), sizeof(it.second));
		txt << it.second;
	}

}

void FromBinaryToText() //из бинарного в текстовый 
{
	BooksInfo info;
	ifstream Bin("FileBin.bin", ios::binary);
	ofstream Text("FileText.txt", ios::app);

	while (Bin.read(reinterpret_cast<char*> (&info), sizeof(info)))
	{
		Text << info;
	}

	Bin.close();
	Text.close();
}

void SearchNumber(int number)
{
	BooksInfo info;
	ifstream Bin;
	int i = 0;
	map <int, BooksInfo> mymap;
	Bin.open("FileBin.bin", ios::binary);
	ofstream Fout;
	Fout.open("SearchFile.txt");
	if (!Fout.is_open())
	{
		throw FileException("Ошибка открытия файла");
	}
	while (!Bin.eof())
	{
		Bin.read(reinterpret_cast<char*> (&info), sizeof(info));
		mymap.emplace(i, info);
		++i;
	}
	auto start = mymap.begin();
	auto end = mymap.end();
	for (auto pos = mymap.begin(); pos != mymap.end(); ++pos)
	{
		if (pos->second.NumLibTicket == number)
		{
			Fout << pos->second;
		}
		else cout << "Не найдено!" << endl;

	}
}

void SearchAuthor()
{
	BooksInfo info;
	ifstream Bin;
	string str;
	int i = 0;
	map <int, BooksInfo> mymap;
	Bin.open("FileBin.bin", ios::binary);
	ofstream Fout;
	Fout.open("SearchFile.txt");
	if (!Fout.is_open())
	{
		throw FileException("Ошибка открытия файла");
	}
	cout << endl << "Введите фамилию автора,которого ищем: ";
	cin >> str;
	while (!Bin.eof())
	{
		Bin.read(reinterpret_cast<char*> (&info), sizeof(info));
		mymap.emplace(i, info);
		++i;
	}
	auto start = mymap.begin();
	auto end = mymap.end();
	for (auto pos = mymap.begin(); pos != mymap.end(); ++pos)
	{
		if (pos->second.Author== str)
		{
			Fout << pos->second;
		}
		else cout << "Не найдено!" << endl;

	}
}

void SearchPubl()
{
	BooksInfo info;
	ifstream Bin;
	string str;
	int i = 0;
	map <int, BooksInfo> mymap;
	Bin.open("FileBin.bin", ios::binary);
	ofstream Fout;
	Fout.open("SearchFile.txt");
	if (!Fout.is_open())
	{
		throw FileException("Ошибка открытия файла");
	}
	cout << endl << "Введите публикацию,которую ищем: ";
	cin >> str;
	while (!Bin.eof())
	{
		Bin.read(reinterpret_cast<char*> (&info), sizeof(info));
		mymap.emplace(i, info);
		++i;
	}
	auto start = mymap.begin();
	auto end = mymap.end();
	for (auto pos = mymap.begin(); pos != mymap.end(); ++pos)
	{
		if (pos->second.Publishing==str)
		{
			Fout << pos->second;
		}
		else cout << "Не найдено!" << endl;

	}

}

void SearchDate()
{
	BooksInfo info;
	ifstream Bin;
	string str;
	int i = 0;
	map <int, BooksInfo> mymap;
	Bin.open("FileBin.bin", ios::binary);
	ofstream Fout;
	Fout.open("SearchFile.txt");
	if (!Fout.is_open())
	{
		throw FileException("Ошибка открытия файла");
	}
	cout << endl << "Введите дату, по которой ищем: ";
	cin >> str;
	while (!Bin.eof())
	{
		Bin.read(reinterpret_cast<char*> (&info), sizeof(info));
		mymap.emplace(i, info);
		++i;
	}
	auto start = mymap.begin();
	auto end = mymap.end();
	for (auto pos = mymap.begin(); pos != mymap.end(); ++pos)
	{
		if (pos->second.Date == str)
		{
			Fout << pos->second;
		}
		else cout << "Не найдено!" << endl;

	}
}